print("Appearance Mod Loaded")

--globfs
-- target getter
function getNewTarget()
	local targetForAppearanceChange = Game.GetTargetingSystem():GetLookAtObject(Game.GetPlayer(), false, false)
	local targetOriginalAppearance = targetForAppearanceChange:GetCurrentAppearanceName() 
	print("Target selected!")
	return targetForAppearanceChange, targetOriginalAppearance
end

-- preset loader
function loadAllSavedPresets(array)
	for i = 1, #array do
		targetExists = array[i].Target:IsAttached()
		if targetExists == true then
			local cntr = #array[i].SavedPreset
			if cntr > 1 then
				if array[i].CurrentPresetID < cntr then
					array[i].CurrentPresetID = array[i].CurrentPresetID + 1
					toapl =array[i].CurrentPresetID
					array[i].Target:PrefetchAppearanceChange(array[i].SavedPreset[toapl])
					array[i].Target:ScheduleAppearanceChange(array[i].SavedPreset[toapl])
				else
					array[i].CurrentPresetID = 1
					array[i].Target:PrefetchAppearanceChange(array[i].SavedPreset[1])
					array[i].Target:ScheduleAppearanceChange(array[i].SavedPreset[1])
				end
			else
				array[i].Target:PrefetchAppearanceChange(array[i].SavedPreset[1])
				array[i].Target:ScheduleAppearanceChange(array[i].SavedPreset[1])
			end
		else
			table.remove(array, i)
		end
	end
end



--
TappManager = {}
TappManager.__index = TappManager

function TappManager:new()
	local obj = {}
		setmetatable(obj, self)
		obj.Target, obj.OriginalPreset = getNewTarget()
	return obj
end

savedPresetArray = {}
savedPresetArray.__index = savedPresetArray

function savedPresetArray:createNew()
	local obj = {}
		setmetatable(obj, self)
		obj.Target = {}
		obj.SavedPreset = {}
		obj.CurrentPresetID = 0
	return obj
end


function savedPresetArray:presetSaveNew(target, appearanceToSave, array)
	if #array == 0 then
		local arraySingle = savedPresetArray:createNew()
		arraySingle.Target = target
		table.insert(arraySingle.SavedPreset, appearanceToSave)
		arraySingle.CurrentPresetID = 1
		table.insert(array, arraySingle)
	else
		for i=1, #array do

			if array[i].Target == target then
				local cntr = array[i].CurrentPresetID+1
				array[i].CurrentPresetID = cntr
				array[i].SavedPreset[cntr] = appearanceToSave
			elseif i==#array then
				local arraySingle = savedPresetArray:createNew()
				arraySingle.Target = target
				table.insert(arraySingle.SavedPreset, appearanceToSave)
				arraySingle.CurrentPresetID = 1
				table.insert(array, arraySingle)
			end
		end
	end
end



function TappManager:changeAppearance(target)
	if target ~= nil then
		targetExists = target:IsAttached()
		if targetExists == true then
			local cn = CName.new
			target:PrefetchAppearanceChange(cn "Randomize")
			target:ScheduleAppearanceChange(cn "Randomize") 
		end
	end
end


function TappManager:savePreset(target, appearanceToSave, savedArray)
	if target ~= nil then
		targetExists = target:IsAttached()
		if targetExists == true then
			savedArray:presetSaveNew(target, appearanceToSave, savedArray)
		end
	end
end

function TappManager:loadFavoritePreset(target, array)
	for i = 1, #array do
		if array[i].Target == target then
			local cntr = #array[i].SavedPreset
			print(cntr)
			if cntr > 1 then
				if array[i].CurrentPresetID < cntr then
					array[i].CurrentPresetID = array[i].CurrentPresetID + 1
					toapl =array[i].CurrentPresetID
					array[i].Target:PrefetchAppearanceChange(array[i].SavedPreset[toapl])
					array[i].Target:ScheduleAppearanceChange(array[i].SavedPreset[toapl])
				else
					array[i].CurrentPresetID = 1
					array[i].Target:PrefetchAppearanceChange(array[i].SavedPreset[1])
					array[i].Target:ScheduleAppearanceChange(array[i].SavedPreset[1])
				end
			else
				array[i].Target:PrefetchAppearanceChange(array[i].SavedPreset[1])
				array[i].Target:ScheduleAppearanceChange(array[i].SavedPreset[1])
			end
		end
	end
end



function TappManager:returnToOriginal(target, original)
	if target ~= nil then
		targetExists = target:IsAttached()
		if targetExists == true then
			target:PrefetchAppearanceChange(original)
			target:ScheduleAppearanceChange(original)
			print("Original appearance returned")
		end
	end
end

arrayOfSavedPresets = savedPresetArray:createNew()


registerForEvent("onUpdate", function(deltaTime)
	if (ImGui.IsKeyPressed(0x70,false)) then -- F1 - choose target
		Targ = TappManager:new()
	elseif (ImGui.IsKeyPressed(0x71,false)) then -- F2 - change appearance
	    Targ:changeAppearance(Targ.Target)
	elseif (ImGui.IsKeyPressed(0x72,false)) then -- F3 - save current target + appearance
		Targ:savePreset(Targ.Target, Targ.Target:GetCurrentAppearanceName(), arrayOfSavedPresets)
	elseif (ImGui.IsKeyPressed(0x73,false)) then -- F4 - load target's favorites
		Targ:loadFavoritePreset(Targ.Target, arrayOfSavedPresets)
	elseif (ImGui.IsKeyPressed(0x77,false)) then -- F8 - load original
		Targ:returnToOriginal(Targ.Target, Targ.OriginalPreset)
	elseif (ImGui.IsKeyPressed(0x78,false)) then -- F9 - load all saved targets & appearances
		loadAllSavedPresets(arrayOfSavedPresets)
	end
end)